#!/usr/local/bin/perl

##############################################################################
# PROGRAM : iLink Search Engine: Main Program                                #
# VERSION : 2000.1.07                                                        #
#                                                                            #
##############################################################################
#                                                                            #
#             __                     __                                      #
#      __    /\ \       __          /\ \                                     #
#     /\_\   \ \ \     /\_\     ___ \ \ \/'\                                 #
#     \/\ \   \ \ \  __\/\ \  /' _ `\\ \ , <                                 #
#      \ \ \   \ \ \L\ \\ \ \ /\ \/\ \\ \ \\`\                               #
#       \ \_\   \ \____/ \ \_\\ \_\ \_\\ \_\ \_\                             #
#        \/_/    \/___/   \/_/ \/_/\/_/ \/_/\/_/                             #
#                                                                            #     
#                                     ___      __      __      __            #
#                                   /'___`\  /'__`\  /'__`\  /'__`\          #
#                                  /\_\ /\ \/\ \/\ \/\ \/\ \/\ \/\ \         #
#                                  \/_/// /_\ \ \ \ \ \ \ \ \ \ \ \ \        #
#                                     // /_\ \ \ \_\ \ \ \_\ \ \ \_\ \       #
#                                    /\______/\ \____/\ \____/\ \____/       #
#                                    \/_____/  \/___/  \/___/  \/___/        #
#                                                                            #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996,1997,1998,1999,2000                                     #
#                                                                            #
#           John C. Cokos, The CCS Network, Inc.  IWeb, Inc.                 #
#           All Rights Reserved.                                             #
#                                                                            #
# Use, distibution, sale, or access to this program is forbidden without     #
# permission, except were permitted by the license agreement.                #
#                                                                            #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
#    Modification of the souce code of this program violates the             #
#    license agreement, and terminates your right to technical support.      #
#                                                                            #
##############################################################################
#START#

package IWEB;


BEGIN { 
   use Cwd;
}

BEGIN {
   $directory = cwd;
   push @INC,$directory;
   push @INC,"."; 
   push @INC,"..";
}


BEGIN { 
   use IWeb::iweb; 
   use IWeb::ilink; 
}

use vars qw(@categories);

use strict;

##############################################################################
# BEGIN OF ACTUAL PROGRAM CODE
##############################################################################


IWEB::Start_Program();

sub Start_Program {

###################################################################
##   See what the user sent as variables and take action          #
###################################################################

  IWEB::Read_Config();

  IWEB::Read_Language("ilink");
  IWEB::Read_Language("global");

  %input=IWEB::parse_form("input");

  ## TESTING
  # $ENV{'SCRIPT_NAME'} = "ilink.cgi";
  # $input{'action'} = "Search";
  # $input{'Terms'} = "internet";

  ## For bannermaster
  if($global{'DB_Format'} eq "SQL") { IWEB::SQL_Connect(); }

  $hyperseek{'small_folder'} = qq! <IMG SRC="$global{'button_dir'}/none.gif" BORDER=0> !;

  #### File names / etc sent from html
  $hyperseek{'database'} = "$data_dir/ilink/hyperseek.dat";
  $hyperseek{'tempdb'} = "$data_dir/ilink/hyperseek.temp";
  $hyperseek{'catdb'} = "$data_dir/ilink/subcategories.dat";
  
  $hyperseek{'Category'} = $input{'Category'};

  @categories = IWEB::ReadCategories();

  $action = $input{'action'};

  if ($input{'Terms'}) { $hyperseek{'template'} = "search";  $hyperseek{original_terms} = $input{Terms}; }
  elsif ($action eq "Add_Link") { $hyperseek{'template'} = "add_url"; }
  elsif ($hyperseek{'Category'}) { $hyperseek{'template'} = IWEB::Make_Alpha($hyperseek{'Category'}); $hyperseek{original_terms} = $input{Category};}
  else { $hyperseek{'template'} = "ilink"; }

  IWEB::Page_Header($hyperseek{'template'});

  IWEB::Quit();

}


sub BODY {

   my($body) = undef;

   if ($action eq "Search") { $body = IWEB::DoSearch(); }
   elsif ($action eq "Add_Link") { $body = IWEB::Add_Form(); }
   elsif ($action eq "post_new") { $body = IWEB::Post_New(); }
   else { $body = IWEB::Category_Listings(); }

   return($body);
}


sub DoSearch {

    my ($catsplit,@Terms,$IDX_File,$check_special,$searchterm,$term,$sterm,$terms,$found,$shown,$outlinks,$header);
    my ($temp,$tempterms,$DEL,$allterms,%entered,%quoted,$footer,@results,$count,%scores,$end,$start);

   ## SETUP ##
        $terms = lc($input{'Terms'});
        $terms =~ s/\'//;

        $hyperseek{'original_terms'} = $terms;
        $hyperseek{'encoded_terms'} = IWEB::urlencode($hyperseek{'original_terms'});

        $hyperseek{'phrase'} = $input{'Terms'};
        $hyperseek{'phrase'} =~ s/ /_/g;
        $hyperseek{'phrase'} =~ s/\"//g;

        $hyperseek{'search_range'} = $input{'howmuch'};
        if (! $hyperseek{'search_range'}) { $hyperseek{'search_range'} = "ALL"; }
        if ($hyperseek{'search_range'} ne "ALL") {
            $hyperseek{'search_cat'} = $hyperseek{'search_range'};
        }
     
        ## Split out the mailto, ID, and URL requests ...
        $DEL = "http://";
        $check_special = $terms;
        $check_special =~ s/$DEL//g; 

        ($hyperseek{'prefix'},$sterm)= split(/\:/,$check_special);
        if ($sterm) {
              $input{'Range'} = "Any";
              $hyperseek{'Search_By'} = lc($hyperseek{'prefix'});
              $hyperseek{'Search_By'} =~ s/ //g;
              $hyperseek{'original_terms'} = $sterm;
              $hyperseek{'encoded_terms'} = IWEB::urlencode($hyperseek{'original_terms'});
              $terms = $sterm;
              $terms =~ s/ //g;
        }
     
        undef $allterms;
        undef @Terms;

        $tempterms = $terms;

        ## Make a space delimited string of terms, using "_" in any quoted term
        while( $tempterms =~ m{"([^\"\\]*(?:\\.[^\"\\]*)*)"}gx ) { 
          $temp = IWEB::ul($1);
          $terms =~ s/$1/$temp/g;
        }
        $terms =~ s/\"//g;

        foreach $searchterm( split(/\s+/,$terms) ) {
           $searchterm =~ s/_/ /g;
           if(! $hyperseek{'grp'}) { $hyperseek{'grp'} = IWEB::Make_Alpha($searchterm); }
           if($allterms) { $allterms .= " $searchterm"; }
           else { $allterms = $searchterm; }
        }

        ## Change operational vars into codes
        $allterms =~ s/ and not / -/ig;
        $allterms =~ s/ not / -/ig;
        $allterms =~ s/ and / \+/ig;
        $allterms =~ s/ or / \|/ig;
        # $allterms =~ s/(\+\+)/$hyperseek{'cpp'}/g;
        $allterms =~ s/(\*+)/$hyperseek{'WildCard'}/g;


        ## Now, foreach term, do the magic.
        foreach $searchterm( split(/ /,$allterms) ) {

           if($ignored{$searchterm}) { 
              $forbidden{$searchterm}++; 
              next;
           } 

           # Determine if it's required, optional, or screened
           if( substr($searchterm,0,1) eq "+") { 
               $searchterm =~s/\+//;
               $required{$searchterm}++;
               $searchterm = quotemeta($searchterm);
               $hyperseek{'required'} .= "(?=.*$searchterm)";
           }      
           elsif( substr($searchterm,0,1) eq "-") { 
               $searchterm =~s/\-//;
               $screen{$searchterm}++;
               $searchterm = quotemeta($searchterm);
               $hyperseek{'screened'} .= "(?=.*$searchterm)";
           }      
           elsif( substr($searchterm,0,1) eq "|") { 
               $searchterm =~s/\|//;
               $optional{$searchterm}++;
               $searchterm = quotemeta($searchterm);
               $hyperseek{'optional'} .= "(?=.*$searchterm)";
           }      
           else {
               $required{$searchterm}++;
               $searchterm = quotemeta($searchterm);
               $hyperseek{'required'} .= "(?=.*$searchterm)";
           }

        }

   ## END SETUP ##

   open(IDB,$hyperseek{'database'});
      my @database = <IDB>;
   close(IDB);

   ## precomile
   my $check = '';

      $check  = 'while (@database) {';
      $check .= '  $_ = shift(@database);';
      $check .= '  chomp;';
      $check .= '  ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/);';
      $check .= '  if($hyperseek{required}) {';
      $check .= '     if($Title =~ m/$hyperseek{required}/i) { $scores{$ID} += 10; }';
      $check .= '     if($Description =~ m/$hyperseek{required}/i) { $scores{$ID} += 8; }';
      $check .= '     if($Category =~ m/$hyperseek{required}/i) { $scores{$ID} += 7; }';
      $check .= '  }';

      $check .= '  if($hyperseek{optional}) {';
      $check .= '    if($Title =~ m/$hyperseek{required}/i) { $scores{$ID} += 3; }';
      $check .= '    if($Description =~ m/$hyperseek{required}/i) { $scores{$ID} += 2; }';
      $check .= '    if($Category =~ m/$hyperseek{required}/i) { $scores{$ID} += 1; }';
      $check .= '  }';

      $check .= '  if($hyperseek{screened}) {';
      $check .= '    if($_ =~ m/$hyperseek{screened}/i) { delete $scores{$ID}; }';
      $check .= '  }';
      
      $check .= '  if($scores{$ID}) {'; 
      $check .= '    @{$results[$count++]}{qw(ID Cat ELink Cool Qualifier Email Title URL Description Keys desc_image title_tag site_icon Name Address City State Zip Country Phone Fax field1 field2 field3 field4 field5)} = split(/\|/);';
      $check .= '    $results[$count]{Score} = $scores{$ID};';
      $check .= '  }';
      $check .= '}';

      eval($check);


   @results = sort { $b->{'Score'} <=> $a->{'Score'} } @results;


   if(! $input{'start'}) { $input{'start'}=0; }
   $start = $input{'start'}+1;

   ## LISTINGS

   for $x (0 .. $#results) { 
      $found++;
      next if ($input{'start'} && $found <= $input{'start'});
      next if($shown >= $global{'ilink_hits_per_page'});
         $shown++;
         if($results[$x]{'URL'}) {
            $outlinks .= qq! <A HREF="$results[$x]{'URL'}" TARGET="$global{'ilink_target'}">$results[$x]{'Title'}</A>
                              <BR>$results[$x]{'Description'}<P>\n !;
         }
         else {
            $outlinks .= qq!  <B>$results[$x]{'Title'}</B><BR>$results[$x]{'Description'}<P>\n ! if($results[$x]{'ID'} > 1);
         }
   }

   $hyperseek{'shown'} = $input{'start'} + $shown;
   $hyperseek{'remaining'} = $#results - $hyperseek{'shown'};
   $hyperseek{'previous'} = $input{'start'} - $global{'ilink_hits_per_page'};
   $hyperseek{'next'} = $input{'start'} + $global{'ilink_hits_per_page'};
   $end = $input{'start'} + $global{'ilink_hits_per_page'};
   $end = $#results if($hyperseek{'remaining'} < 1);


   ## FOOTER ##
   $footer = "<CENTER>\n";

   if($input{'start'}) { 
          $footer .= qq! 
            <A HREF="$PROG_URL?action=Search&Terms=$hyperseek{'encoded_terms'}&start=$hyperseek{'previous'}">$language{'previous'}</A>
          !;
   }

   if($hyperseek{'remaining'} >= 1) { 
          $footer .= qq! 
            <A HREF="$PROG_URL?action=Search&Terms=$hyperseek{'encoded_terms'}&start=$hyperseek{'next'}">$language{'next'}</A>
          !;
   }

   $footer .= "</CENTER>\n";

   ## HEADER
   if(@results) { 
      $header = "<B>$#results $language{'found'} ... $language{'showing'} $start - $end</B><BR><BR>\n";
   }
   else {
      $header = "<B>0 $language{'found'}</B><BR><BR>\n";
   }

   return("$header $outlinks $footer");
}



sub CategorySelectList { 

    my(@categories,$catselect,$x,$tmpc) = undef;

    @categories = IWEB::ReadCategories();

    $catselect = "$language{'category_prompt'}      <SELECT NAME=\"category\">\n";

       for $x (0 .. $#categories ) {

           $tmpc = "$categories[$x]{'Category'}:$categories[$x]{'SubCategory'}";
 
           if ($tmpc eq $hyperseek{'Category'}) {
              $catselect .= "<OPTION VALUE=\"$tmpc\" SELECTED>$tmpc\n"; 
           }
           else {
              $catselect .= "<OPTION VALUE=\"$tmpc\">$tmpc\n"; 
           }
       }

       $catselect .= "</SELECT><BR>\n";

}

sub ReadCategories {

    my($sub_count,@tmp_subs,$rec,$tmp_subs,%tmp_subs,@sub_categories);

    open (CAT,"$hyperseek{'catdb'}");
      while ( <CAT> ) {
        $tmp_subs={};
        foreach $rec(split /\n/,join '',<CAT>){
 	  (undef,
	   @{$tmp_subs[$sub_count++]}{qw(Category SubCategory Count Teaser_Flag)})=split(/\|/,$rec,5);
        }
      }
    close (CAT);  

    @sub_categories = sort { $a->{'Category'} cmp $b->{'Category'} 
      or  $a->{'SubCategory'} cmp $b->{'SubCategory'} } @tmp_subs;

    return(@sub_categories);

}

sub Add_Form {

    my ($catlist) = IWEB::CategorySelectList();

    my $f1 = qq! <FONT FACE="$global{'font_face'}" COLOR="$global{'text_color'}" SIZE="$global{'font_size'}"> !;
    my $f2 = qq! </FONT> !;
    
    my ($addform) = qq!

       <form NAME="rply_form" METHOD="POST" ACTION="$PROG_URL" ENCTYPE="x-www-form-urlencoded">
          <TABLE BORDER=0>
          <TR><TD COLSPAN=2>$f1 $catlist $f2</TD></TR>

          <TR><TD>$f1 $language{'name_prompt'} $f2</TD>
             <TD><input NAME="a_name" TYPE="text" SIZE="30"></TD></TR>
          <TR><TD>$f1 $language{'email_prompt'} $f2</TD>
             <TD><input NAME="a_email" TYPE="text" SIZE="30"></TD></TR>
          <TR><TD>$f1 $language{'title_prompt'} $f2</TD>
             <TD><input NAME="a_title" TYPE="text" SIZE="30" MAXLENGTH="40"></TD></TR>
          <TR><TD>$f1 $language{'url_prompt'}  $f2</TD> 
             <TD><input NAME="a_url" TYPE="text" VALUE="http://" SIZE="40"></TD></TR>

          <TR><TD COLSPAN=2>$f1 $language{'description_prompt'}....$f2</TD>
          <TR><TD COLSPAN=2><textarea NAME="a_text" WRAP="virtual" ROWS="3" COLS="30"></textarea></TD></TR>
          <TR><TD COLSPAN=2>$f1 <input type="checkbox" name="do_spellcheck">$language{'spell_prompt'} $f2</TD></TR>
          <TR><TD COLSPAN=2>
             <CENTER>
             $f1
             <input NAME=b_post" TYPE="submit" VALUE="$language{'addlink_button'}">
             <input NAME="action" TYPE="hidden" VALUE="post_new">
             $f2
             </CENTER>
          </TD></TR>
          </TABLE>
       </form>

    !;

    return($addform);
}


sub Post_New {

    my $gt="&gt;";
    my $lt="&lt;";
    my $newline = undef;


    ## Check Spelling
    if($input{'do_spellcheck'}) {
       ($bad,$badmsg) = IWEB::Spelling_Errors($input{'a_text'}, "$data_dir/dictionary");
       if ( $bad ) { 
          $err = IWEB::ERROR($bad); 
          IWEB::iWeb_Header($err);
          IWEB::Quit(); 
       }
    }
 
    if( ! IWEB::lock("hyperseek")) { 
       $err = IWEB::ERROR("Server is busy");
       IWEB::iWeb_Header($err);
       IWEB::Quit();
    }

       ### Make the entry ###
       $time = time;
       $input{'a_xtra'} =~ s/\r\n/ /g;

       ### Screw with the Description a bit.
       ## We need to change "|" into "%%%%"
       $input{'a_text'} =~ s/\|/\%\%\%\%/g;
       ## Respect webmasters HTML wishes
       $input{'a_text'} = IWEB::Remove_HTML_Tags($input{'a_text'});
       ## Change \r\n into <BR> <CR> so that we can use the formatting entered.
       $input{'a_text'} =~ s/\r\n/<CR>/g;


      ### FINALLY ... Save it.

      $newline = "$time|";
      $newline .= "$input{'category'}|";
      $newline .= "|";
      $newline .= "$global{'Default_Rank'}|";
      $newline .= "$input{'Qualifier'}|";
      $newline .= "$input{'a_email'}|";
      $newline .= "$input{'a_title'}|";
      $newline .= "$input{'a_url'}|";
      $newline .= "$input{'a_text'}|";
      $newline .= "$input{'a_xtra'}|";          
      $newline .= "$input{'title_tag'}|";  
      $newline .= "$input{'desc_icon'}|";  
      $newline .= "$input{'site_icon'}|";  
      $newline .= "$input{'a_name'}|";  
      $newline .= "$input{'a_address'}|";  
      $newline .= "$input{'a_city'}|";  
      $newline .= "$input{'a_state'}|";  
      $newline .= "$input{'a_zip'}|";  
      $newline .= "$input{'a_country'}|";  
      $newline .= "$input{'a_phone'}|";  
      $newline .= "$input{'a_fax'}|";  
      $newline .= "$input{'startdate'}|";
      $newline .= "$input{'enddate'}|";
      $newline .= "$input{'price'}|";
      $newline .= "$input{'account'}|";
      $newline .= "$input{'xfactor'}|";
      $newline .= "$input{'field1'}|";
      $newline .= "$input{'field2'}|";
      $newline .= "$input{'field3'}|";
      $newline .= "$input{'field4'}|";
      $newline .= "$input{'field5'}|";
      $newline .= "$input{'field6'}|";
      $newline .= "$input{'field7'}|";
      $newline .= "$input{'field8'}|";
      $newline .= "$input{'field9'}|";
      $newline .= "$input{'field10'}|\n";

      open (MSG,">>$data_dir/ilink/hyperseek.temp");
        print MSG "$newline";
      close(MSG);

    IWEB::unlock("hyperseek");

    print "Location: $global{'ilink_thanks'}\n\n";   

    IWEB::Quit(); 

}


sub ul {

   my $string = $_[0];

   $string =~ s/ /_/g;

   return ($string);
}

